Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::gui::IGUIElement Class Reference

Base class of all GUI elements. More...

`#include <IGUIElement.h>`

Inheritance diagram for irr::gui::IGUIElement:

List of all members.

## Public Member Functions
virtual void | addChild (IGUIElement *child)
| Adds a GUI element as new child of this element.
virtual bool | bringToFront (IGUIElement *element)
| Brings a child to front.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the scene node.
virtual void | draw ()
| Draws the element and its children.
core::rect< s32 > | getAbsoluteClippingRect () const
| Returns the visible area of the element.
core::rect< s32 > | getAbsolutePosition () const
| Gets the absolute rectangle of this element.
virtual const core::list < IGUIElement * > & | getChildren () const
| Returns list with children of this element.
virtual IGUIElement * | getElementFromId (s32 id, bool searchchildren=false) const
| Finds the first element with the given id.
IGUIElement * | getElementFromPoint (const core::position2d< s32 > &point)
| Returns the topmost GUI element at the specific position.
virtual s32 | getID () const
| Returns id. Can be used to identify the element.
bool | getNextElement (s32 startOrder, bool reverse, bool group, IGUIElement *&first, IGUIElement *&closest, bool includeInvisible=false) const
| searches elements to find the closest next element to tab to
IGUIElement * | getParent () const
| Returns parent of this element.
core::rect< s32 > | getRelativePosition () const
| Returns the relative rectangle of this element.
IGUIElement * | getTabGroup ()
| Returns the container element which holds all elements in this element's tab group.
s32 | getTabOrder () const
| Returns the number in the tab order sequence.
virtual const wchar_t * | getText () const
| Returns caption of this element.
virtual const core::stringw & | getToolTipText () const
| Returns caption of this element.
EGUI_ELEMENT_TYPE | getType () const
| Returns the type of the gui element.
virtual const c8 * | getTypeName () const
| Returns the type name of the gui element.
| IGUIElement (EGUI_ELEMENT_TYPE type, IGUIEnvironment *environment, IGUIElement *parent, s32 id, core::rect< s32 > rectangle)
| Constructor.
virtual bool | isEnabled () const
| Returns true if element is enabled.
bool | isMyChild (IGUIElement *child) const
bool | isNotClipped () const
| Gets whether the element will ignore its parent's clipping rectangle.
virtual bool | isPointInside (const core::position2d< s32 > &point) const
| Returns true if a point is within this element.
virtual bool | isSubElement () const
| Returns true if this element was created as part of its parent control.
bool | isTabGroup () const
| Returns true if this element is a tab group.
bool | isTabStop () const
| Returns true if this element can be focused by navigating with the tab key.
virtual bool | isVisible () const
| Returns true if element is visible.
virtual void | move (core::position2d< s32 > absoluteMovement)
| Moves this element.
virtual bool | OnEvent (const SEvent &event)
| Called if an event happened.
virtual void | OnPostRender (u32 timeMs)
| animate the element and its children.
virtual void | remove ()
| Removes this element from its parent.
virtual void | removeChild (IGUIElement *child)
| Removes a child.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the scene node.
void | setAlignment (EGUI_ALIGNMENT left, EGUI_ALIGNMENT right, EGUI_ALIGNMENT top, EGUI_ALIGNMENT bottom)
virtual void | setEnabled (bool enabled)
| Sets the enabled state of this element.
virtual void | setID (s32 id)
| Sets the id of this element.
void | setMaxSize (core::dimension2du size)
| Sets the maximum size allowed for this element.
void | setMinSize (core::dimension2du size)
| Sets the minimum size allowed for this element.
void | setNotClipped (bool noClip)
| Sets whether the element will ignore its parent's clipping rectangle.
void | setRelativePosition (const core::position2di &position)
| Sets the relative rectangle of this element, maintaining its current width and height.
void | setRelativePosition (const core::rect< s32 > &r)
| Sets the relative rectangle of this element.
void | setRelativePositionProportional (const core::rect< f32 > &r)
| Sets the relative rectangle of this element as a proportion of its parent's area.
virtual void | setSubElement (bool subElement)
| Sets whether this control was created as part of its parent.
void | setTabGroup (bool isGroup)
| Sets whether this element is a container for a group of elements which can be navigated using the tab key.
void | setTabOrder (s32 index)
| Sets the priority of focus when using the tab key to navigate between a group of elements.
void | setTabStop (bool enable)
| If set to true, the focus will visit this element when using the tab key to cycle through elements.
virtual void | setText (const wchar_t *text)
| Sets the new caption of this element.
virtual void | setToolTipText (const wchar_t *text)
| Sets the new caption of this element.
virtual void | setVisible (bool visible)
| Sets the visible state of this element.
virtual void | updateAbsolutePosition ()
| Updates the absolute position.
virtual | ~IGUIElement ()
| Destructor.
## Protected Attributes
core::rect< s32 > | AbsoluteClippingRect
| absolute clipping rect of element
core::rect< s32 > | AbsoluteRect
| absolute rect of element
EGUI_ALIGNMENT | AlignBottom
EGUI_ALIGNMENT | AlignLeft
| tells the element how to act when its parent is resized
EGUI_ALIGNMENT | AlignRight
EGUI_ALIGNMENT | AlignTop
core::list< IGUIElement * > | Children
| List of all children of this element.
core::rect< s32 > | DesiredRect
IGUIEnvironment * | Environment
| GUI Environment.
s32 | ID
| id
bool | IsEnabled
| is enabled?
bool | IsSubElement
| is a part of a larger whole and should not be serialized?
bool | IsTabGroup
| tab groups are containers like windows, use ctrl+tab to navigate
bool | IsTabStop
| tab stop like in windows
bool | IsVisible
| is visible?
core::rect< s32 > | LastParentRect
| for calculating the difference when resizing parent
core::dimension2du | MaxSize
| maximum and minimum size of the element
core::dimension2du | MinSize
bool | NoClip
| does this element ignore its parent's clipping rectangle?
IGUIElement * | Parent
| Pointer to the parent.
core::rect< s32 > | RelativeRect
| relative rect of element
core::rect< f32 > | ScaleRect
| relative scale of the element inside its parent
s32 | TabOrder
| tab order
core::stringw | Text
| caption
core::stringw | ToolTipText
| tooltip
EGUI_ELEMENT_TYPE | Type
| type of element

## Detailed Description

Base class of all GUI elements.

Definition at line 25 of file IGUIElement.h.

## Constructor & Destructor Documentation

irr::gui::IGUIElement::IGUIElement | ( | EGUI_ELEMENT_TYPE | type,
|  | IGUIEnvironment * | environment,
|  | IGUIElement * | parent,
|  | s32 | id,
|  | core::rect< s32 > | rectangle |
| ) |  |  | `[inline]`

Constructor.

Definition at line 30 of file IGUIElement.h.

References addChild(), and irr::IReferenceCounted::setDebugName().

virtual irr::gui::IGUIElement::~IGUIElement | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 51 of file IGUIElement.h.

References Children.

## Member Function Documentation

virtual void irr::gui::IGUIElement::addChild | ( | IGUIElement * | child | ) | `[inline, virtual]`

Adds a GUI element as new child of this element.

Definition at line 389 of file IGUIElement.h.

References Children, getAbsolutePosition(), irr::IReferenceCounted::grab(), LastParentRect, Parent, remove(), and updateAbsolutePosition().

Referenced by IGUIElement().

virtual bool irr::gui::IGUIElement::bringToFront | ( | IGUIElement * | element | ) | `[inline, virtual]`

Brings a child to front.

Returns:
  True if successful, false if not.

Definition at line 637 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and Children.

virtual void irr::gui::IGUIElement::deserializeAttributes | ( | io::IAttributes * | in,
|  | io::SAttributeReadWriteOptions * | options = `0` |
| ) |  |  | `[inline, virtual]`

Reads attributes of the scene node.

Implement this to set the attributes of your scene node for scripting languages, editors, debuggers or xml deserialization purposes.

Reimplemented from irr::io::IAttributeExchangingObject.

Definition at line 837 of file IGUIElement.h.

References irr::core::string< T, TAlloc >::c_str(), irr::io::IAttributes::getAttributeAsBool(), irr::io::IAttributes::getAttributeAsEnumeration(), irr::io::IAttributes::getAttributeAsInt(), irr::io::IAttributes::getAttributeAsPosition2d(), irr::io::IAttributes::getAttributeAsRect(), irr::io::IAttributes::getAttributeAsStringW(), irr::gui::GUIAlignmentNames, IsTabGroup, IsTabStop, setAlignment(), setEnabled(), setID(), setMaxSize(), setMinSize(), setNotClipped(), setRelativePosition(), setText(), setVisible(), TabOrder, irr::core::vector2d< T >::X, and irr::core::vector2d< T >::Y.

virtual void irr::gui::IGUIElement::draw | ( |  | ) | `[inline, virtual]`

Draws the element and its children.

Definition at line 426 of file IGUIElement.h.

References Children, and isVisible().

core::rect<s32> irr::gui::IGUIElement::getAbsoluteClippingRect | ( |  | ) | const`[inline]`

Returns the visible area of the element.

Definition at line 144 of file IGUIElement.h.

References AbsoluteClippingRect.

core::rect<s32> irr::gui::IGUIElement::getAbsolutePosition | ( |  | ) | const`[inline]`

Gets the absolute rectangle of this element.

Definition at line 137 of file IGUIElement.h.

References AbsoluteRect.

Referenced by addChild(), setAlignment(), setRelativePosition(), and setRelativePositionProportional().

virtual const core::list<IGUIElement*>& irr::gui::IGUIElement::getChildren | ( |  | ) | const`[inline, virtual]`

Returns list with children of this element.

Definition at line 656 of file IGUIElement.h.

References Children.

virtual IGUIElement* irr::gui::IGUIElement::getElementFromId | ( | s32 | id,
|  | bool | searchchildren = `false` |
| ) |  |  | const`[inline, virtual]`

Finds the first element with the given id.

Parameters:

  | id,: | Id to search for.
  | searchchildren,: | Set this to true, if also children of this element may contain the element with the searched id and they should be searched too.

Returns:
  Returns the first element with the given id. If no element with this id was found, 0 is returned.

Definition at line 669 of file IGUIElement.h.

References Children, and getElementFromId().

Referenced by getElementFromId().

IGUIElement* irr::gui::IGUIElement::getElementFromPoint | ( | const core::position2d< s32 > & | point | ) | `[inline]`

Returns the topmost GUI element at the specific position.

This will check this GUI element and all of its descendants, so it may return this GUI element. To check all GUI elements, call this function on device->getGUIEnvironment()->getRootGUIElement(). Note that the root element is the size of the screen, so doing so (with an on-screen point) will always return the root element if no other element is above it at that point.

Parameters:

  | point,: | The point at which to find a GUI element.

Returns:
  The topmost GUI element at that point, or 0 if there are no candidate elements at this point.

Definition at line 352 of file IGUIElement.h.

References Children, getElementFromPoint(), isPointInside(), and isVisible().

Referenced by getElementFromPoint().

virtual s32 irr::gui::IGUIElement::getID | ( |  | ) | const`[inline, virtual]`

Returns id. Can be used to identify the element.

Definition at line 615 of file IGUIElement.h.

References ID.

bool irr::gui::IGUIElement::getNextElement | ( | s32 | startOrder,
|  | bool | reverse,
|  | bool | group,
|  | IGUIElement *& | first,
|  | IGUIElement *& | closest,
|  | bool | includeInvisible = `false` |
| ) |  |  | const`[inline]`

searches elements to find the closest next element to tab to

Parameters:

  | startOrder,: | The TabOrder of the current element, -1 if none
  | reverse,: | true if searching for a lower number
  | group,: | true if searching for a higher one
  | first,: | element with the highest/lowest known tab order depending on search direction
  | closest,: | the closest match, depending on tab order and direction
  | includeInvisible,: | includes invisible elements in the search (default=false)

Returns:
  true if successfully found an element, false to continue searching/fail

Definition at line 716 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, Children, and getTabOrder().

Referenced by setTabOrder().

IGUIElement* irr::gui::IGUIElement::getParent | ( |  | ) | const`[inline]`

Returns parent of this element.

Definition at line 64 of file IGUIElement.h.

References Parent.

Referenced by getTabGroup().

core::rect<s32> irr::gui::IGUIElement::getRelativePosition | ( |  | ) | const`[inline]`

Returns the relative rectangle of this element.

Definition at line 71 of file IGUIElement.h.

References RelativeRect.

IGUIElement* irr::gui::IGUIElement::getTabGroup | ( |  | ) | `[inline]`

Returns the container element which holds all elements in this element's tab group.

Definition at line 560 of file IGUIElement.h.

References getParent(), and isTabGroup().

Referenced by setTabOrder().

s32 irr::gui::IGUIElement::getTabOrder | ( |  | ) | const`[inline]`

Returns the number in the tab order sequence.

Definition at line 536 of file IGUIElement.h.

References TabOrder.

Referenced by getNextElement(), and setTabOrder().

virtual const wchar_t* irr::gui::IGUIElement::getText | ( |  | ) | const`[inline, virtual]`

Returns caption of this element.

Definition at line 594 of file IGUIElement.h.

References irr::core::string< T, TAlloc >::c_str(), and Text.

Referenced by serializeAttributes().

virtual const core::stringw& irr::gui::IGUIElement::getToolTipText | ( |  | ) | const`[inline, virtual]`

Returns caption of this element.

Definition at line 608 of file IGUIElement.h.

References ToolTipText.

EGUI_ELEMENT_TYPE irr::gui::IGUIElement::getType | ( |  | ) | const`[inline]`

Returns the type of the gui element.

This is needed for the .NET wrapper but will be used later for serializing and deserializing. If you wrote your own GUIElements, you need to set the type for your element as first parameter in the constructor of IGUIElement. For own (=unknown) elements, simply use EGUIET_ELEMENT as type

Definition at line 796 of file IGUIElement.h.

References Type.

virtual const c8* irr::gui::IGUIElement::getTypeName | ( |  | ) | const`[inline, virtual]`

Returns the type name of the gui element.

This is needed serializing elements. For serializing your own elements, override this function and return your own type name which is created by your IGUIElementFactory

Definition at line 805 of file IGUIElement.h.

References irr::gui::GUIElementTypeNames, and Type.

virtual bool irr::gui::IGUIElement::isEnabled | ( |  | ) | const`[inline, virtual]`

Returns true if element is enabled.

Definition at line 572 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsEnabled.

bool irr::gui::IGUIElement::isMyChild | ( | IGUIElement * | child | ) | const`[inline]`

returns true if the given element is a child of this one.

Parameters:

  | child,: | The child element to check

Definition at line 692 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and Parent.

bool irr::gui::IGUIElement::isNotClipped | ( |  | ) | const`[inline]`

Gets whether the element will ignore its parent's clipping rectangle.

Returns:
  true if the element is not clipped by its parent's clipping rectangle.

Definition at line 161 of file IGUIElement.h.

References NoClip.

virtual bool irr::gui::IGUIElement::isPointInside | ( | const core::position2d< s32 > & | point | ) | const`[inline, virtual]`

Returns true if a point is within this element.

Elements with a shape other than a rectangle should override this method

Definition at line 382 of file IGUIElement.h.

References AbsoluteClippingRect.

Referenced by getElementFromPoint().

virtual bool irr::gui::IGUIElement::isSubElement | ( |  | ) | const`[inline, virtual]`

Returns true if this element was created as part of its parent control.

Definition at line 472 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsSubElement.

bool irr::gui::IGUIElement::isTabGroup | ( |  | ) | const`[inline]`

Returns true if this element is a tab group.

Definition at line 552 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsTabGroup.

Referenced by getTabGroup().

bool irr::gui::IGUIElement::isTabStop | ( |  | ) | const`[inline]`

Returns true if this element can be focused by navigating with the tab key.

Definition at line 498 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsTabStop.

virtual bool irr::gui::IGUIElement::isVisible | ( |  | ) | const`[inline, virtual]`

Returns true if element is visible.

Definition at line 457 of file IGUIElement.h.

References _IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX, and IsVisible.

Referenced by draw(), getElementFromPoint(), and OnPostRender().

virtual void irr::gui::IGUIElement::move | ( | core::position2d< s32 > | absoluteMovement | ) | `[inline, virtual]`

Moves this element.

Definition at line 450 of file IGUIElement.h.

References DesiredRect, and setRelativePosition().

virtual bool irr::gui::IGUIElement::OnEvent | ( | const SEvent & | event | ) | `[inline, virtual]`

Called if an event happened.

Implements irr::IEventReceiver.

Definition at line 629 of file IGUIElement.h.

References OnEvent(), and Parent.

Referenced by OnEvent().

virtual void irr::gui::IGUIElement::OnPostRender | ( | u32 | timeMs | ) | `[inline, virtual]`

animate the element and its children.

Definition at line 438 of file IGUIElement.h.

References Children, and isVisible().

virtual void irr::gui::IGUIElement::remove | ( |  | ) | `[inline, virtual]`

Removes this element from its parent.

Definition at line 418 of file IGUIElement.h.

References Parent, and removeChild().

Referenced by addChild().

virtual void irr::gui::IGUIElement::removeChild | ( | IGUIElement * | child | ) | `[inline, virtual]`

Removes a child.

Definition at line 403 of file IGUIElement.h.

References Children.

Referenced by remove().

virtual void irr::gui::IGUIElement::serializeAttributes | ( | io::IAttributes * | out,
|  | io::SAttributeReadWriteOptions * | options = `0` |
| ) |  |  | const`[inline, virtual]`

Writes attributes of the scene node.

Implement this to expose the attributes of your scene node for scripting languages, editors, debuggers or xml serialization purposes.

Reimplemented from irr::io::IAttributeExchangingObject.

Definition at line 814 of file IGUIElement.h.

References irr::io::IAttributes::addBool(), irr::io::IAttributes::addEnum(), irr::io::IAttributes::addInt(), irr::io::IAttributes::addPosition2d(), irr::io::IAttributes::addRect(), irr::io::IAttributes::addString(), AlignBottom, AlignLeft, AlignRight, AlignTop, DesiredRect, getText(), irr::gui::GUIAlignmentNames, irr::core::dimension2d< T >::Height, ID, IsEnabled, IsTabGroup, IsTabStop, IsVisible, MaxSize, MinSize, NoClip, TabOrder, and irr::core::dimension2d< T >::Width.

void irr::gui::IGUIElement::setAlignment | ( | EGUI_ALIGNMENT | left,
|  | EGUI_ALIGNMENT | right,
|  | EGUI_ALIGNMENT | top,
|  | EGUI_ALIGNMENT | bottom |
| ) |  |  | `[inline]`

Definition at line 188 of file IGUIElement.h.

References AlignBottom, AlignLeft, AlignRight, AlignTop, DesiredRect, irr::gui::EGUIA_SCALE, getAbsolutePosition(), Parent, and ScaleRect.

Referenced by deserializeAttributes().

virtual void irr::gui::IGUIElement::setEnabled | ( | bool | enabled | ) | `[inline, virtual]`

Sets the enabled state of this element.

Definition at line 580 of file IGUIElement.h.

References IsEnabled.

Referenced by deserializeAttributes().

virtual void irr::gui::IGUIElement::setID | ( | s32 | id | ) | `[inline, virtual]`

Sets the id of this element.

Definition at line 622 of file IGUIElement.h.

References ID.

Referenced by deserializeAttributes().

void irr::gui::IGUIElement::setMaxSize | ( | core::dimension2du | size | ) | `[inline]`

Sets the maximum size allowed for this element.

If set to 0,0, there is no maximum size

Definition at line 169 of file IGUIElement.h.

References MaxSize, and updateAbsolutePosition().

Referenced by deserializeAttributes().

void irr::gui::IGUIElement::setMinSize | ( | core::dimension2du | size | ) | `[inline]`

Sets the minimum size allowed for this element.

Definition at line 177 of file IGUIElement.h.

References irr::core::dimension2d< T >::Height, MinSize, updateAbsolutePosition(), and irr::core::dimension2d< T >::Width.

Referenced by deserializeAttributes().

void irr::gui::IGUIElement::setNotClipped | ( | bool | noClip | ) | `[inline]`

Sets whether the element will ignore its parent's clipping rectangle.

Parameters:

  | noClip | If true, the element will not be clipped by its parent's clipping rectangle.

Definition at line 152 of file IGUIElement.h.

References NoClip, and updateAbsolutePosition().

Referenced by deserializeAttributes().

void irr::gui::IGUIElement::setRelativePosition | ( | const core::position2di & | position | ) | `[inline]`

Sets the relative rectangle of this element, maintaining its current width and height.

Parameters:

  | position | The new relative position to set. Width and height will not be changed.

Definition at line 103 of file IGUIElement.h.

References irr::core::dimension2d< T >::Height, RelativeRect, setRelativePosition(), irr::core::dimension2d< T >::Width, irr::core::vector2d< T >::X, and irr::core::vector2d< T >::Y.

void irr::gui::IGUIElement::setRelativePosition | ( | const core::rect< s32 > & | r | ) | `[inline]`

Sets the relative rectangle of this element.

Parameters:

  | r | The absolute position to set

Definition at line 79 of file IGUIElement.h.

References AlignBottom, AlignLeft, AlignRight, AlignTop, DesiredRect, irr::gui::EGUIA_SCALE, getAbsolutePosition(), irr::core::rect< T >::getSize(), irr::core::dimension2d< T >::Height, irr::core::rect< T >::LowerRightCorner, Parent, ScaleRect, updateAbsolutePosition(), irr::core::rect< T >::UpperLeftCorner, and irr::core::dimension2d< T >::Width.

Referenced by deserializeAttributes(), move(), and setRelativePosition().

void irr::gui::IGUIElement::setRelativePositionProportional | ( | const core::rect< f32 > & | r | ) | `[inline]`

Sets the relative rectangle of this element as a proportion of its parent's area.

Note:
  This method used to be 'void setRelativePosition(const core::rect<f32>& r)'

Parameters:

  | r | The rectangle to set, interpreted as a proportion of the parent's area. Meaningful values are in the range [0...1], unless you intend this element to spill outside its parent.

Definition at line 117 of file IGUIElement.h.

References DesiredRect, irr::core::floor32(), getAbsolutePosition(), irr::core::dimension2d< T >::Height, irr::core::rect< T >::LowerRightCorner, Parent, ScaleRect, updateAbsolutePosition(), irr::core::rect< T >::UpperLeftCorner, and irr::core::dimension2d< T >::Width.

virtual void irr::gui::IGUIElement::setSubElement | ( | bool | subElement | ) | `[inline, virtual]`

Sets whether this control was created as part of its parent.

For example, it is true when a scrollbar is part of a listbox. SubElements are not saved to disk when calling guiEnvironment->saveGUI()

Definition at line 482 of file IGUIElement.h.

References IsSubElement.

void irr::gui::IGUIElement::setTabGroup | ( | bool | isGroup | ) | `[inline]`

Sets whether this element is a container for a group of elements which can be navigated using the tab key.

For example, windows are tab groups. Groups can be navigated using ctrl+tab, providing isTabStop is true.

Definition at line 545 of file IGUIElement.h.

References IsTabGroup.

void irr::gui::IGUIElement::setTabOrder | ( | s32 | index | ) | `[inline]`

Sets the priority of focus when using the tab key to navigate between a group of elements.

See setTabGroup, isTabGroup and getTabGroup for information on tab groups. Elements with a lower number are focused first

Definition at line 508 of file IGUIElement.h.

References getNextElement(), getTabGroup(), getTabOrder(), IsTabGroup, Parent, and TabOrder.

void irr::gui::IGUIElement::setTabStop | ( | bool | enable | ) | `[inline]`

If set to true, the focus will visit this element when using the tab key to cycle through elements.

If this element is a tab group (see isTabGroup/setTabGroup) then ctrl+tab will be used instead.

Definition at line 491 of file IGUIElement.h.

References IsTabStop.

virtual void irr::gui::IGUIElement::setText | ( | const wchar_t * | text | ) | `[inline, virtual]`

Sets the new caption of this element.

Definition at line 587 of file IGUIElement.h.

References Text.

Referenced by deserializeAttributes().

virtual void irr::gui::IGUIElement::setToolTipText | ( | const wchar_t * | text | ) | `[inline, virtual]`

Sets the new caption of this element.

Definition at line 601 of file IGUIElement.h.

References ToolTipText.

virtual void irr::gui::IGUIElement::setVisible | ( | bool | visible | ) | `[inline, virtual]`

Sets the visible state of this element.

Definition at line 465 of file IGUIElement.h.

References IsVisible.

Referenced by deserializeAttributes().

virtual void irr::gui::IGUIElement::updateAbsolutePosition | ( |  | ) | `[inline, virtual]`

Updates the absolute position.

Definition at line 214 of file IGUIElement.h.

References AbsoluteClippingRect, AbsoluteRect, AlignBottom, AlignLeft, AlignRight, AlignTop, Children, DesiredRect, irr::gui::EGUIA_CENTER, irr::gui::EGUIA_LOWERRIGHT, irr::gui::EGUIA_SCALE, irr::gui::EGUIA_UPPERLEFT, irr::core::rect< T >::getHeight(), irr::core::rect< T >::getWidth(), irr::core::dimension2d< T >::Height, LastParentRect, MaxSize, MinSize, NoClip, Parent, RelativeRect, ScaleRect, irr::core::rect< T >::UpperLeftCorner, and irr::core::dimension2d< T >::Width.

Referenced by addChild(), setMaxSize(), setMinSize(), setNotClipped(), setRelativePosition(), and setRelativePositionProportional().

## Member Data Documentation

core::rect<s32> irr::gui::IGUIElement::AbsoluteClippingRect`[protected]`

absolute clipping rect of element

Definition at line 878 of file IGUIElement.h.

Referenced by getAbsoluteClippingRect(), isPointInside(), and updateAbsolutePosition().

core::rect<s32> irr::gui::IGUIElement::AbsoluteRect`[protected]`

absolute rect of element

Definition at line 875 of file IGUIElement.h.

Referenced by getAbsolutePosition(), and updateAbsolutePosition().

EGUI_ALIGNMENT irr::gui::IGUIElement::AlignBottom`[protected]`

Definition at line 924 of file IGUIElement.h.

Referenced by serializeAttributes(), setAlignment(), setRelativePosition(), and updateAbsolutePosition().

EGUI_ALIGNMENT irr::gui::IGUIElement::AlignLeft`[protected]`

tells the element how to act when its parent is resized

Definition at line 924 of file IGUIElement.h.

Referenced by serializeAttributes(), setAlignment(), setRelativePosition(), and updateAbsolutePosition().

EGUI_ALIGNMENT irr::gui::IGUIElement::AlignRight`[protected]`

Definition at line 924 of file IGUIElement.h.

Referenced by serializeAttributes(), setAlignment(), setRelativePosition(), and updateAbsolutePosition().

EGUI_ALIGNMENT irr::gui::IGUIElement::AlignTop`[protected]`

Definition at line 924 of file IGUIElement.h.

Referenced by serializeAttributes(), setAlignment(), setRelativePosition(), and updateAbsolutePosition().

core::list<IGUIElement*> irr::gui::IGUIElement::Children`[protected]`

List of all children of this element.

Definition at line 866 of file IGUIElement.h.

Referenced by addChild(), bringToFront(), draw(), getChildren(), getElementFromId(), getElementFromPoint(), getNextElement(), OnPostRender(), removeChild(), updateAbsolutePosition(), and ~IGUIElement().

core::rect<s32> irr::gui::IGUIElement::DesiredRect`[protected]`

the rectangle the element would prefer to be, if it was not constrained by parent or max/min size

Definition at line 882 of file IGUIElement.h.

Referenced by move(), serializeAttributes(), setAlignment(), setRelativePosition(), setRelativePositionProportional(), and updateAbsolutePosition().

IGUIEnvironment* irr::gui::IGUIElement::Environment`[protected]`

GUI Environment.

Definition at line 927 of file IGUIElement.h.

s32 irr::gui::IGUIElement::ID`[protected]`

id

Definition at line 912 of file IGUIElement.h.

Referenced by getID(), serializeAttributes(), and setID().

bool irr::gui::IGUIElement::IsEnabled`[protected]`

is enabled?

Definition at line 897 of file IGUIElement.h.

Referenced by isEnabled(), serializeAttributes(), and setEnabled().

bool irr::gui::IGUIElement::IsSubElement`[protected]`

is a part of a larger whole and should not be serialized?

Definition at line 900 of file IGUIElement.h.

Referenced by isSubElement(), and setSubElement().

bool irr::gui::IGUIElement::IsTabGroup`[protected]`

tab groups are containers like windows, use ctrl+tab to navigate

Definition at line 921 of file IGUIElement.h.

Referenced by deserializeAttributes(), isTabGroup(), serializeAttributes(), setTabGroup(), and setTabOrder().

bool irr::gui::IGUIElement::IsTabStop`[protected]`

tab stop like in windows

Definition at line 915 of file IGUIElement.h.

Referenced by deserializeAttributes(), isTabStop(), serializeAttributes(), and setTabStop().

bool irr::gui::IGUIElement::IsVisible`[protected]`

is visible?

Definition at line 894 of file IGUIElement.h.

Referenced by isVisible(), serializeAttributes(), and setVisible().

core::rect<s32> irr::gui::IGUIElement::LastParentRect`[protected]`

for calculating the difference when resizing parent

Definition at line 885 of file IGUIElement.h.

Referenced by addChild(), and updateAbsolutePosition().

core::dimension2du irr::gui::IGUIElement::MaxSize`[protected]`

maximum and minimum size of the element

Definition at line 891 of file IGUIElement.h.

Referenced by serializeAttributes(), setMaxSize(), and updateAbsolutePosition().

core::dimension2du irr::gui::IGUIElement::MinSize`[protected]`

Definition at line 891 of file IGUIElement.h.

Referenced by serializeAttributes(), setMinSize(), and updateAbsolutePosition().

bool irr::gui::IGUIElement::NoClip`[protected]`

does this element ignore its parent's clipping rectangle?

Definition at line 903 of file IGUIElement.h.

Referenced by isNotClipped(), serializeAttributes(), setNotClipped(), and updateAbsolutePosition().

IGUIElement* irr::gui::IGUIElement::Parent`[protected]`

Pointer to the parent.

Definition at line 869 of file IGUIElement.h.

Referenced by addChild(), getParent(), isMyChild(), OnEvent(), remove(), setAlignment(), setRelativePosition(), setRelativePositionProportional(), setTabOrder(), and updateAbsolutePosition().

core::rect<s32> irr::gui::IGUIElement::RelativeRect`[protected]`

relative rect of element

Definition at line 872 of file IGUIElement.h.

Referenced by getRelativePosition(), setRelativePosition(), and updateAbsolutePosition().

core::rect<f32> irr::gui::IGUIElement::ScaleRect`[protected]`

relative scale of the element inside its parent

Definition at line 888 of file IGUIElement.h.

Referenced by setAlignment(), setRelativePosition(), setRelativePositionProportional(), and updateAbsolutePosition().

s32 irr::gui::IGUIElement::TabOrder`[protected]`

tab order

Definition at line 918 of file IGUIElement.h.

Referenced by deserializeAttributes(), getTabOrder(), serializeAttributes(), and setTabOrder().

core::stringw irr::gui::IGUIElement::Text`[protected]`

caption

Definition at line 906 of file IGUIElement.h.

Referenced by getText(), and setText().

core::stringw irr::gui::IGUIElement::ToolTipText`[protected]`

tooltip

Definition at line 909 of file IGUIElement.h.

Referenced by getToolTipText(), and setToolTipText().

EGUI_ELEMENT_TYPE irr::gui::IGUIElement::Type`[protected]`

type of element

Definition at line 930 of file IGUIElement.h.

Referenced by getType(), and getTypeName().

The documentation for this class was generated from the following file:

- IGUIElement.h

| The Irrlicht Engine Documentation © 2003-2009 by Nikolaus Gebhardt. Generated on Sun Jan 10 09:24:10 2010 by Doxygen (1.5.6)